part of 'blocs.dart';

typedef BaseBackendInitializer<T, B extends Backend> = FutureOr<B> Function(
  BackendArgument<T> argument,
);

class BaseBlocBackend extends Backend {
  BaseBlocBackend(BackendArgument<void> argument) : super(argument: argument);

  @override
  @mustCallSuper
  void initActions() {}
}

class BasePagingBlocBackend<D> extends BaseBlocBackend {
  BasePagingBlocBackend(BackendArgument<void> argument) : super(argument);

  @override
  @mustCallSuper
  void initActions() {
    super.initActions();
    whenEventCome('SortingEvent').run(sort);
  }

  @protected
  Future<List<D>> sort({
    required String event,
    required Tuple2<List<D>, CompareFunction<D>> data,
  }) async {
    data.item1.sort(data.item2);
    return data.item1;
  }
}
